/*
    tstore - an archive format for archiving tar archives
    Copyright (C) 2004-2005  Kasper Dupont

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    with permission from the author any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    $Id: hash.c,v 1.6 2005/04/11 08:33:14 kasperd Exp $
*/

#include "tstore.h"
#include "md5.h"

uint8_t hash_key[16];

void hash_buf(uint8_t *buf, int size)
{
  memcpy(buf,hash_key,16);
  if (size<512) memset(buf+16+size,0,512-size);
  md5_buffer(buf,HBS,buf);
}

ssize_t read_and_hash(int fd, uint8_t *buf)
{
  ssize_t r=myread(fd,buf+16,512);
  if ((r<1)||(r>512)) return r;
  hash_buf(buf,r);
  return r;
}
