/*
    tstore - an archive format for archiving tar archives
    Copyright (C) 2005  Kasper Dupont

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    with permission from the author any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    $Id: tdelete.c,v 1.2 2005/04/24 14:09:49 kasperd Exp $
*/

#include "tstore.h"


int main(int argc, char ** argv)
{
  struct store *s;
  uint8_t buf[512];

  if (argc != 2) {
    fprintf(stderr,"Uage: %s <store>\n",argv[0]);
    return EXIT_FAILURE;
  }

  s=open_store(argv[1],O_RDWR,CHECK_LOCK);
  if (!s) errstop(argv[1]);

  assert(pread(s->fd,buf,512,512*GET_BNUM(s->header_buf+NEXTPTR_OFFSET))==512);

  fprintf(stderr,"Are you sure you want to delete \"%s\" from \"%s\"? ",
	  buf+FILENAME_OFFSET,argv[1]);
  if (!confirm()) cancel();
  if (unlink(s->h32name)&&(errno!=ENOENT)) errstop(s->h32name);
  if (lock_store(s)) errstop(s->name);
  assert(pwrite(s->fd,buf+STORESIZE_OFFSET,10,STORESIZE_OFFSET)==10);
  if(ftruncate(s->fd,512*GET_BNUM(buf+STORESIZE_OFFSET))&&(errno!=EINVAL))
    errstop(s->name);
  close_store(s);
  return 0;

}
